local addon, ns = ...

_G[addon] = ns

local warcraftLogsButton = true

local destUnit = {}

local frame = CreateFrame('Frame', nil, UIParent)
frame:SetFrameStrata('TOOLTIP')
frame:SetSize(200, 20)
--[==[
frame.bg = frame:CreateTexture()
frame.bg:SetPoint('TOPLEFT', frame, 'TOPLEFT', 0, 0)
frame.bg:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', 0, 0)
frame.bg:SetColorTexture(1,0,0,0.7)
]==]
frame:SetBackdrop({
		bgFile = [[Interface\Buttons\WHITE8x8]],
		edgeFile = [[Interface\Buttons\WHITE8x8]],
		edgeSize = 1,
		insets = {left = 0, right = 0, top = 0, bottom =0}
	})
frame:SetBackdropColor(0 , 0 , 0 , 0.8) --цвет фона
frame:SetBackdropBorderColor(0 , 0 , 0 , 1) --цвет фона
	
frame.button = CreateFrame('Frame', nil, frame)
frame.button:SetSize(20, 20)
frame.button:EnableMouse(true)
frame.button:SetPoint('TOPLEFT', frame, 'TOPLEFT', 0,0)
frame.button:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', 0,0)
frame.button.text = frame.button:CreateFontString()
frame.button.text:SetFont(STANDARD_TEXT_FONT, 12)
frame.button.text:SetPoint('LEFT', frame, 'LEFT', 2, 0)
frame.button.text:SetText(addon)

frame.button.bg = frame.button:CreateTexture()
frame.button.bg:SetPoint('TOPLEFT', frame.button, 'TOPLEFT', 0, 0)
frame.button.bg:SetPoint('BOTTOMRIGHT', frame.button, 'BOTTOMRIGHT', 0, 0)
frame.button.bg:SetColorTexture(1,1,1,0.3)
frame.button.bg:Hide()
frame.button:SetScript('OnEnter', function(self)
	self.bg:Show()
	frame.dropdown:Show()
end)
frame.button:SetScript('OnLeave', function(self)
	self.bg:Hide()
end)
			
frame.dropdown = CreateFrame('Frame', nil, frame)
frame.dropdown:SetFrameStrata('TOOLTIP')
frame.dropdown:SetSize(200, 20)
frame.dropdown:SetPoint('TOPLEFT', frame, 'TOPRIGHT', 0, 0)
--[==[
frame.dropdown.bg = frame.dropdown:CreateTexture()
frame.dropdown.bg:SetPoint('TOPLEFT', frame.dropdown, 'TOPLEFT', 0, 0)
frame.dropdown.bg:SetPoint('BOTTOMRIGHT', frame.dropdown, 'BOTTOMRIGHT', 0, 0)
frame.dropdown.bg:SetColorTexture(0,1,0,0.7)
]==]
frame.dropdown:SetBackdrop({
		bgFile = [[Interface\Buttons\WHITE8x8]],
		edgeFile = [[Interface\Buttons\WHITE8x8]],
		edgeSize = 1,
		insets = {left = 0, right = 0, top = 0, bottom =0}
	})
frame.dropdown:SetBackdropColor(0 , 0 , 0 , 0.8) --цвет фона
frame.dropdown:SetBackdropBorderColor(0 , 0 , 0 , 1) --цвет фона

frame.dropdown:Hide()
frame.dropdown.buttons = {}

frame.dropdown.cancel = CreateFrame('Button', nil, frame.dropdown)
frame.dropdown.cancel:SetSize(20,20)
frame.dropdown.cancel:EnableMouse(true)
frame.dropdown.cancel:SetPoint('BOTTOMRIGHT', frame.dropdown, 'BOTTOMRIGHT', -2,3)
frame.dropdown.cancel:SetPoint('BOTTOMLEFT', frame.dropdown, 'BOTTOMLEFT', 2,3)
frame.dropdown.cancel:SetScript('OnClick', function(self)	
	frame:Hide()
	frame.dropdown:Hide()
end)
frame.dropdown.cancel.text = frame.dropdown.cancel:CreateFontString()
frame.dropdown.cancel.text:SetFont(STANDARD_TEXT_FONT, 12)
frame.dropdown.cancel.text:SetPoint('LEFT', frame.dropdown.cancel, 'LEFT', 2, 0)
frame.dropdown.cancel.text:SetText('Cancel')
frame.dropdown.cancel.bg = frame.dropdown.cancel:CreateTexture()
frame.dropdown.cancel.bg:SetPoint('TOPLEFT', frame.dropdown.cancel, 'TOPLEFT', 0, 0)
frame.dropdown.cancel.bg:SetPoint('BOTTOMRIGHT', frame.dropdown.cancel, 'BOTTOMRIGHT', 0, 0)
frame.dropdown.cancel.bg:SetColorTexture(1,1,1,0.3)
frame.dropdown.cancel.bg:Hide()
frame.dropdown.cancel:SetScript('OnEnter', function(self)
	self.bg:Show()
end)
frame.dropdown.cancel:SetScript('OnLeave', function(self)
	self.bg:Hide()
end)
frame.dropdown.cancel.separator = frame.dropdown.cancel:CreateTexture()
frame.dropdown.cancel.separator:SetPoint('BOTTOMLEFT', frame.dropdown.cancel, 'TOPLEFT',5, 0)
frame.dropdown.cancel.separator:SetPoint('BOTTOMRIGHT', frame.dropdown.cancel, 'TOPRIGHT',-5, 0)
frame.dropdown.cancel.separator:SetTexture("Interface\\Common\\UI-TooltipDivider-Transparent")

 -- "Interface\\Common\\UI-TooltipDivider-Transparent"

frame.dropdown.WCLButton = CreateFrame('Button', nil, frame.dropdown)
frame.dropdown.WCLButton:SetSize(20,20)
frame.dropdown.WCLButton:EnableMouse(true)
frame.dropdown.WCLButton:SetScript('OnClick', function(self)				
	ns:Popup(destUnit[self.index])
end)
frame.dropdown.WCLButton.text = frame.dropdown.WCLButton:CreateFontString()
frame.dropdown.WCLButton.text:SetFont(STANDARD_TEXT_FONT, 12)
frame.dropdown.WCLButton.text:SetPoint('LEFT', frame.dropdown.WCLButton, 'LEFT', 2, 0)
frame.dropdown.WCLButton.text:SetText('WarcraftLogs')
frame.dropdown.WCLButton.bg = frame.dropdown.WCLButton:CreateTexture()
frame.dropdown.WCLButton.bg:SetPoint('TOPLEFT', frame.dropdown.WCLButton, 'TOPLEFT', 0, 0)
frame.dropdown.WCLButton.bg:SetPoint('BOTTOMRIGHT', frame.dropdown.WCLButton, 'BOTTOMRIGHT', 0, 0)
frame.dropdown.WCLButton.bg:SetColorTexture(1,1,1,0.3)
frame.dropdown.WCLButton.bg:Hide()
frame.dropdown.WCLButton:SetScript('OnEnter', function(self)
	self.bg:Show()
end)
frame.dropdown.WCLButton:SetScript('OnLeave', function(self)
	self.bg:Hide()
end)
frame.dropdown.WCLButton.separator = frame.dropdown.WCLButton:CreateTexture()
frame.dropdown.WCLButton.separator:SetPoint('BOTTOMLEFT', frame.dropdown.WCLButton, 'TOPLEFT',5, 0)
frame.dropdown.WCLButton.separator:SetPoint('BOTTOMRIGHT', frame.dropdown.WCLButton, 'TOPRIGHT',-5, 0)
frame.dropdown.WCLButton.separator:SetTexture("Interface\\Common\\UI-TooltipDivider-Transparent")

function ns.BuidDropDown()
	local size = 3
	
	for i=1,  #frame.dropdown.buttons do
		frame.dropdown.buttons[i]:Hide()
	end
	
	for i=1,  #ns.linkList do
		if not frame.dropdown.buttons[i] then
			local button = CreateFrame('Button', nil, frame.dropdown)
			button:SetSize(20,20)
			button:EnableMouse(true)
			button:SetScript('OnClick', function(self)				
				ns:Popup(destUnit[self.index])
			end)
			button.text = button:CreateFontString()
			button.text:SetFont(STANDARD_TEXT_FONT, 12)
			button.text:SetPoint('LEFT', button, 'LEFT', 2, 0)
			button.text:SetText(ns.linkList[i][1])
			
		
			button.bg = button:CreateTexture()
			button.bg:SetPoint('TOPLEFT', button, 'TOPLEFT', 0, 0)
			button.bg:SetPoint('BOTTOMRIGHT', button, 'BOTTOMRIGHT', 0, 0)
			button.bg:SetColorTexture(1,1,1,0.3)
			button.bg:Hide()
			
			button:SetScript('OnEnter', function(self)
				self.bg:Show()
			end)
			button:SetScript('OnLeave', function(self)
				self.bg:Hide()
			end)
			frame.dropdown.buttons[i] = button
		end
		
		
		local button = frame.dropdown.buttons[i]
		button.index = i
		button:SetPoint('TOPLEFT', frame.dropdown, 'TOPLEFT', 2, -3 - (20*(i-1)))
		button:SetPoint('TOPRIGHT', frame.dropdown, 'TOPRIGHT', -2, -3 - (20*(i-1)))
		button:Show()
		
		size = size + 20
	end
	
	if warcraftLogsButton then
		local lastButton = frame.dropdown.buttons[#ns.linkList]
	
		frame.dropdown.WCLButton.index = #destUnit
		frame.dropdown.WCLButton:SetPoint('TOPLEFT', lastButton, 'BOTTOMLEFT', 0, -7)
		frame.dropdown.WCLButton:SetPoint('TOPRIGHT', lastButton, 'BOTTOMRIGHT', 0, -7)
		frame.dropdown.WCLButton:Show()
		
		size = size + 25
	else
		frame.dropdown.WCLButton:Hide()
	end
	
	if false then
		size = size + 30
		frame.dropdown.cancel:Show()
	else
		size = size + 5
		frame.dropdown.cancel:Hide()
	end
	
	frame.dropdown:SetSize(200, size)	
end


--[==[

	Frame:SetHitRectInsets(left, right, top, bottom)
	left, right, top, bottom = Frame:GetHitRectInsets()
	
]==]

function ns.SetReact()
--	DropDownList1:SetHitRectInsets(0, 100, 25, 0)
end

function ns.RestoreReact()
--	DropDownList1:SetHitRectInsets(0, 0, 0, 0)
end


DropDownList1:HookScript('OnShow', function(self)
	if destUnit[1] then
		frame:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 0,1)
		frame:SetPoint('BOTTOMRIGHT', self, 'TOPRIGHT', 0,1)
		frame:Show()
		
		ns.BuidDropDown()
		ns.SetReact()
	else
		frame:ClearAllPoints()
		frame:Hide()
		frame.dropdown:Hide()
		ns.RestoreReact()
	end
--	print('DropDownList1','OnShow')
end)
DropDownList1:HookScript('OnHide', function(self)
	frame:Hide()
	frame.dropdown:Hide()
	ns.RestoreReact()
--	print('DropDownList1','OnHide')
end)


hooksecurefunc("UnitPopup_ShowMenu", function(self, which, ...)
	local unit, typo
	if which == "FRIEND" then
		unit = select(2, ...)
		typo = 'guid'
	elseif which == 'BN_FRIEND' then
		local btag = select(2, ...)
		
		local totalBNet, numBNetOnline = BNGetNumFriends()
		local _, bnetIDAccount, accountName, battleTag, characterName, bnetIDGameAccount, client, isOnline, isAFK, isDND, noteText
		local hasFocus, realmName, realmID, faction, race, class, guild, zoneName, level, gameText
	
		for i = 1, totalBNet do
			bnetIDAccount, accountName, battleTag, _, characterName, bnetIDGameAccount, client, isOnline, _, isAFK, isDND, _, noteText = BNGetFriendInfo(i)
			hasFocus, _, _, realmName, realmID, faction, race, class, guild, zoneName, level, gameText = BNGetGameAccountInfo(bnetIDGameAccount or bnetIDAccount);
	
			if accountName == btag and isOnline and client == 'WoW' then --16
			--	print('accountName=',accountName,'isOnline=',isOnline, 'characterName=', characterName,'realmName=',realmName,'realmID=',realmID,'client=',client)
				
				unit = characterName..'-'..realmName:gsub(' ', '')
				typo = 'guid'
				break
			end
		end
	elseif which == 'GUILD' then
		unit = select(2, ...)
		typo = 'guid'
	else
		unit = ...
	end
	
	ns.SetData(unit,typo)	
--	print('UnitPopup_ShowMenu unit=', unit, UnitIsPlayer(unit), 'other=', which, ...)
end)

hooksecurefunc('LFGListUtil_GetApplicantMemberMenu', function(applicantID, memberIdx)
	local name, class, localizedClass, level, itemLevel, tank, healer, damage, assignedRole = C_LFGList.GetApplicantMemberInfo(applicantID, memberIdx);
    local id, status, pendingStatus, numMembers, isNew, comment = C_LFGList.GetApplicantInfo(applicantID);

	ns.SetData(name,'guid')
--	print('LFGListUtil_GetApplicantMemberMenu', name)
end)

-- DropDownList1
hooksecurefunc('LFGListUtil_GetSearchEntryMenu', function(resultID)
	local id, activityID, name, comment, voiceChat, iLvl, honorLevel, age, numBNetFriends, numCharFriends, numGuildMates, isDelisted, leaderName = C_LFGList.GetSearchResultInfo(resultID);
	local _, appStatus, pendingStatus, appDuration = C_LFGList.GetApplicationInfo(resultID);

	ns.SetData(leaderName,'guid')	
--	print('T', leaderName)
end)

hooksecurefunc('ToggleDropDownMenu', function(a1, a2, f)
	if f == LFGListLanguageFilterDropDownFrame or f == QueueStatusMinimapButtonDropDown then
		wipe(destUnit)
		frame:Hide()
		frame.dropdown:Hide()
		ns.RestoreReact()
	elseif f == FriendsDropDown or f == GuildMemberDropDown or f == LFGListFrameDropDown or f == SecureTemplatesDropdown then
		ns.SetReact()
	elseif f then
		wipe(destUnit)
		frame:Hide()
		frame.dropdown:Hide()
		ns.RestoreReact()
	--	print('ToggleDropDownMenu', f, f and f:GetName())
	end
end)

function ns.SetData(unit, typo)
--	print('SetData', unit, typo)
	
	local id, realmName, apiName, rules, locale, battlegroup, region, timezone, connections, latinName, latinApiName
	local name
	
	wipe(destUnit)
	frame.dropdown:Hide()
	
	if typo == 'guid' and unit then
		name, server = strsplit('-', unit)
		
		if name and not server then
			server = GetRealmName():gsub(' ', '')
		end
		
		id, realmName, apiName, rules, locale, battlegroup, region, timezone, connections, latinName, latinApiName = ns.RealmInfo:GetRealmInfo(server)
	elseif unit and UnitIsPlayer(unit) then
		name = UnitName(unit)
		
		id, realmName, apiName, rules, locale, battlegroup, region, timezone, connections, latinName, latinApiName = ns.RealmInfo:GetRealmInfoByUnit(unit)
	else
	--	print('ClearData')
		return
	end
	
	if not realmName then
		print('Cant find info for', unit, typo, name, server)
		return
	end
	
	ns.CreateLinks(name, realmName, apiName, locale, id, region, latinName, latinApiName, connections)
end

ns.linkList = {}

function ns.AddLink(tag, handler)
	ns.linkList[#ns.linkList+1] = { tag, handler}
end

function ns.CreateLinks(name, realmName, apiName, locale, id, region, latinName, latinApiName)
	for i=1, #ns.linkList do
		
		local link = ns.linkList[i][2](name, realmName, apiName, locale, id, region, latinName, latinApiName)
		
		destUnit[#destUnit+1] = link or 'none'
	end
	
	-- WarcraftLogs
	if warcraftLogsButton then
		local pattern = 'https://www.warcraftlogs.com/character/%s/%s/%s' -- region, ream, name
		local realmName1
		
		if latinName then
			realmName1 = string.lower(realmName:gsub(' ', '-'):gsub("'", ''))
			realmName1 = ns.RemoveLatinAbbrev(realmName1)
		else
			realmName1 = string.lower(realmName:gsub(' ', '-'):gsub("'", ''))
		end
		
		destUnit[#destUnit+1] = string.format(pattern, string.lower(region), realmName1, string.lower(name))
	end
end

do
	local width = 500
	
	local editBox
	local hide
	local frame = CreateFrame("Frame", nil, UIParent)

	frame:SetBackdrop({
			bgFile = [[Interface\Buttons\WHITE8x8]],
			edgeFile = [[Interface\Buttons\WHITE8x8]],
			edgeSize = 1,
			insets = {left = 0, right = 0, top = 0, bottom =0}
		})
	frame:SetBackdropColor(0 , 0 , 0 , 0.7) --цвет фона
	frame:SetBackdropBorderColor(0 , 0 , 0 , 1) --цвет фона
	
	frame:SetSize(width, 40)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:SetFrameStrata("DIALOG")
	frame:Hide()

	editBox = CreateFrame("EditBox", nil, frame)
	editBox:SetFontObject(ChatFontNormal)
	editBox:SetSize(width-120, 40)
	editBox:SetPoint("LEFT", frame, "LEFT", 10, 0)
	
	hide = function(f) f:GetParent():Hide() end
	
	editBox:SetScript("OnEscapePressed", hide)
	editBox:SetScript('OnTextChanged', function(self, userInput)
		if userInput then
			if self.lastText then				
				self:SetText(self.lastText)
			end
		end
	end)
	--[==[
	local fsting = editBox:CreateFontString()
	fsting:SetFontObject(ChatFontNormal)
	fsting:SetFont(STANDARD_TEXT_FONT, 12, 'NONE')
	fsting:SetPoint("LEFT", editBox, "RIGHT", 5, 0)
	fsting:SetText('|cFF606060Ctrl+C - '..'COPY'..'\nCtrl+V - '..'PASTE'..'|r')
	fsting:SetJustifyH('LEFT')
	]==]
	local close_ = CreateFrame("Button", nil, frame)
	close_:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
	close_:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
	close_:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight", "ADD")
	close_:SetSize(32, 32)
	close_:SetPoint("RIGHT", frame, "RIGHT", -5, 0)
	close_:SetScript("OnClick", hide)
	
	--[[ End popup creation ]]--
	
	-- Avoiding StaticPopup taints by making our own popup, rather that adding to the StaticPopup list
	function ns:Popup(text)
		frame:SetSize(width, 40)
		editBox:SetSize(width-40, 40)
		editBox:SetMultiLine(false)			
		editBox.lastText = text
		editBox:SetText(text)
		editBox:HighlightText();
		editBox:GetParent():Show()
	end
end

-- https://www.warcraftlogs.com/character/eu/%s/%s , server name

ns.AddLink('Armory', function(name, realm, apiName, locale, id, region, latinName, latinApiName, connections)
	local pattern = 'https://worldofwarcraft.com/%s/character/%s/%s' -- region latinRealm, name
	
--	print('name=',realm, 'api=',apiName, 'locale=', locale, 'id=',id,'region=',region,'latinApi=',latinApiName, 'conn=', connections and #connections)
	
	local realmName
	
	if latinName then
		realmName = string.lower(latinName:gsub(' ', '-'):gsub("'", ''))
	else
		realmName = string.lower(realm:gsub(' ', '-'):gsub("'", ''))
	end
	
	local regionName
	if region == 'EU' then
		regionName = 'en-gb'
	elseif region == 'US' then
		regionName = 'en-us'
	elseif region == 'CN' then
		regionName = 'zh-cn'
	else		
		regionName = locale:sub(1, 2)..'-'..locale:sub(3, 4)
	end
--	print(regionName, realmName, name, ns.RebuildRealmRegion(realmName))
	
	return string.format(pattern, string.lower(regionName), realmName, string.lower(name))
end)

-- - вместо апосрофов
ns.AddLink('WoWProgress', function(name, realm, apiName, locale, id, region, latinName, latinApiName)
	-- https://www.wowprogress.com/character/eu/well-of-eternity/Randolfr
	local pattern = 'https://www.wowprogress.com/character/%s/%s/%s' -- region, ream, name
	
	local realmName = string.lower(realm:gsub(' ', '-'):gsub("'", '-'))

	return string.format(pattern, string.lower(region), realmName, string.lower(name))
end)
ns.AddLink('RaiderIO', function(name, realm, apiName, locale, id, region, latinName, latinApiName)
	local pattern = 'https://raider.io/characters/%s/%s/%s' -- region, latinRealm, name
	local realmName
	
	if latinName then
		realmName = string.lower(latinName:gsub(' ', '-'))
	else
		realmName = string.lower(realm:gsub(' ', '-'))
	end
	
	return string.format(pattern, string.lower(region), realmName, string.lower(name))
end)



function ns.RebuildRealmRegion(realm)
	local realm1, region = string.match(realm, '(.+) %((.+)%)')
	if not realm or not region then
		return realm
	end	
	return realm1..'-'..region
end

do
	local list = {
		['й'] = 'и',
		['ё'] = 'е',
	}
	
	function ns.RemoveLatinAbbrev(realm)
		if not realm then
			return realm
		end
		
		for k,v in pairs(list) do
			realm = realm:gsub(k,v)
		end
		
		return realm
	end
end

ns.fixServers = {
	['Король лич'] = 'Король-лич',
}